import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)

import java.awt.Font;
import java.awt.Color;

/**
 * Counter that displays a number.
 * 
 * @author Michael Kolling
 * @version 1.0.1
 */
public class Puntaje extends Actor
{
    private int value = 0;
    private int target = 0;
    private String text;
    private int stringLength;

    public Puntaje()
    {
        this("");
       
    }

    public Puntaje(String prefix)
    {
        text = prefix;
        stringLength = (text.length() + 2) * 16;

        setImage(new GreenfootImage(stringLength, 24));
        GreenfootImage image = getImage();
        Font font = image.getFont();
        image.setFont(font.deriveFont(24.0F));  // use larger font
        image.setColor(Color.WHITE);
        updateImage();
    }
    
    public void act() {
        if(value < target) {
            value++;
            updateImage();
        }
        else if(value > target) {
            value--;
            updateImage();
        }
    }

    public void add(int score,int puntos,int numact)
    {int cont=puntos;
        target += score;    
      if(numact==0){
        if(cont==9&&target>=6){
         ((Mundo) getWorld()).act1Nivel2();//pasa a nivel dos
        }
        else if(cont==9&&target<=5)
        {
           ((Mundo) getWorld()).gameOver();
        }
        else if(cont==19&&target>=16){
            ((Mundo) getWorld()).act1Nivel3();//pasa a nivel 3
        }
        else if(cont==19&&target<=15){
            ((Mundo) getWorld()).gameOver();
        }
        else if(cont==29&&target>=26){
          ((Mundo) getWorld()).ganador();
        }
        else if(cont==29&&target<=25){
          ((Mundo) getWorld()).ganador();
        } 
      }
      else if(numact==1){
       if(cont==5&&target>=3){
         ((Mundo) getWorld()).nivel2A2();
        }
       else if(cont==5&&target<=2){
          ((Mundo) getWorld()).gameOver();
        }
        else if(cont==10&&target>=8){
          ((Mundo) getWorld()).nivel3A2();
        }
        else if(cont==10&&target<=7){
         ((Mundo) getWorld()).gameOver();
        }
        else if(cont==15&&target>=14){
         ((Mundo) getWorld()).ganador();
        }
        else if(cont==15&&target<=13){
         ((Mundo) getWorld()).gameOver();
        }
      }    
    }
    
     public void add2(int score)
    {
        target += score;            
    }

    public void subtract(int score)
    {      
         target -= score;
        if(target < 0){     
          ((Mundo) getWorld()).gameOver();    
        }   
    }

    public int getValue()
    {
        return (value-1);
    }

    /**
     * Make the image
     */
    private void updateImage()
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(text + value, 1, 18);
    }
}